#region Using Statements

using System;
using System.Windows;
using NinjaTrader.Core;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Tools;
using NinjaTrader.NinjaScript;
using System.IO;
using System.Windows.Controls;
using System.Windows.Markup;
using System.Xml.Linq;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using IInstrumentProvider = NinjaTrader.Gui.Tools.IInstrumentProvider;
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;
using NinjaTrader.Gui.Tools;

// Add this to your declarations to use StreamWriter and StreamReader
using System.IO;
using NinjaTrader.Code;
using System.Threading;

// 
// Copyright (C) 2015, NinjaTrader LLC <www.ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

namespace NinjaTrader.NinjaScript.AddOns
{	
	/*
		* This is the Primary script in the set of scripts in this example, This script will be the first called script in NinjaTrader. 
     
		* Unlike other NinjaScript documents, Debugging in an addon can be done unsing the folling statement
		* Output.Process("SomeString", PrintTo.OutputTab1);
    */
	public class MaxTradeLoss : AddOnBase
    {
		//These variables will be used in checking if the current Addon already has a menu item, and also stores the new menu item to be added.
		private NTMenuItem existingMenuItems;
        private NTMenuItem newMenuItem;
		
		private Account myAccount;
		private double MaxProfit, MaxLoss;
		private string	path = NinjaTrader.Core.Globals.UserDataDir + "MaxTradeLoss.txt";
		DateTime LastTimeWritten;
		
        private void OnMenuItemClick(object sender, RoutedEventArgs e)
        {
            Globals.RandomDispatcher.InvokeAsync(new Action(() => new AddonShellNoTabsWindow().Show()));
        }

        protected override void OnStateChange()
        {
            if (State == State.SetDefaults)
            {
                Description = "";
                Name = "MaxTradeLoss";
            }
			else if (State == State.Configure)
			{
			if(!File.Exists(path))
			File.WriteAllText(path, "500");
						
			//Read values on load	
			string readText = File.ReadAllText(path);
				
			MaxLoss=Convert.ToDouble(readText);
				
			LastTimeWritten = File.GetLastWriteTime(path);
				
            foreach (Account myAccount in Account.All)
         	{
				myAccount.AccountItemUpdate  += OnAccountItemUpdate;
			}
			
			}
			else if (State == State.Terminated)
    		{

				foreach (Account myAccount in Account.All)
         		{
				// Unsubscribe to events
        		myAccount.AccountItemUpdate -= OnAccountItemUpdate;
				}
    			}
        }

		private void OnAccountItemUpdate(object sender, AccountItemEventArgs e)
		{	
			//Read values again in case it has been updated
			if(LastTimeWritten != File.GetLastWriteTime(path))
    		{
			string readText = File.ReadAllText(path);			
			MaxLoss=Convert.ToDouble(readText);
			LastTimeWritten = File.GetLastWriteTime(path);
			}
			
			if (e.AccountItem == AccountItem.UnrealizedProfitLoss)
			{				
				if (e.Value < -MaxLoss)
				{				
					System.Collections.ObjectModel.Collection<Cbi.Instrument> instrumentsToCancel = new System.Collections.ObjectModel.Collection<Instrument>(); 
					
					foreach(Position pos in e.Account.Positions)
					{ 
		    		instrumentsToCancel.Add(pos.Instrument); 
					}

					e.Account.Flatten(instrumentsToCancel);
				}
			}
		}
		
        protected override void OnWindowCreated(Window window)
        {
			/*
				* The following checks if the control center window is present.
				* If the control center is found, the MainMenu is checked for existing menu items with the same name as this addon. 
				* If no existing items are found, a new menu item is added for this addon. 
			*/
			ControlCenter controlCenter = window as ControlCenter;

            if (controlCenter == null)
                return;

            existingMenuItems = controlCenter.FindFirst("ControlCenterMenuItemTools") as NTMenuItem;

            if (existingMenuItems == null)
                return;

			// This is the new menu item to be created, this assigns the menu text and will be used to Add this item to the Main Menu. 
			newMenuItem = new NTMenuItem {Header = "Max Loss per Trade", Style = Application.Current.TryFindResource("MainMenuItem") as Style};
			
            existingMenuItems.Items.Add(newMenuItem);
			// The new menu item will do nothing by its self, a click handler is added to complete the menu item and allow for clicks.
			newMenuItem.Click += OnMenuItemClick;
        }

        protected override void OnWindowDestroyed(Window window)
        {
			// This checks if there is not a menu item or if the destroyed window is not the control center.
			if (newMenuItem == null || !(window is ControlCenter) ||
					existingMenuItems == null ||
					!existingMenuItems.Items.Contains(newMenuItem))	
				return;

			// if the destroyed window was the control center, we clean up the click handler and remove the custom menu item and set it to null.
			newMenuItem.Click -= OnMenuItemClick;
			existingMenuItems.Items.Remove(newMenuItem);
			newMenuItem = null;			
        }		
	}

	public class AddonShellNoTabsWindow : NTWindow, IWorkspacePersistence
	{
		private Button myButton;
		private TextBox MaxLossBox, MaxProfitBox;	
		
		private string	path = NinjaTrader.Core.Globals.UserDataDir + "MaxTradeLoss.txt";
				
		/*
			* This is the constructor for the new NTWindow.
			* This document sets up the basic window before it gets displayed.
			* This also defines what TabPage will be used and the Window Factory that will be used in the window creation process.
			* This document is also where you would set Tab defaults like if this window will have a tab control, if the tabs are movable etc..
		*/
		public AddonShellNoTabsWindow()
		{
			Caption	= "Account Protection";
			Width	= 400;
			Height	= 200;
			Content	= LoadXaml();

			// This is a inline Window Loaded handler, once the window loads, if the WorkspaceOptions are not present,
			// a new WorkspaceOptions object is created for this window using its GUID.
			Loaded += (o, e) =>
			{
				if (WorkspaceOptions == null)
				{
					WorkspaceOptions = new WorkspaceOptions("AccountProtection" + Guid.NewGuid().ToString("N"), this);
				}
			};
			
			Closing += (o, e) =>
			{
				if (myButton != null)
					myButton.Click -= myButton_Click;
			};
		}

		private async void myButton_Click(object sender, RoutedEventArgs e)
		{
			//NinjaTrader.Code.Output.Process("Button clicked", PrintTo.OutputTab1);
										
			File.WriteAllText(path, MaxLossBox.Text);
			
			myButton.Background = Brushes.Green;
			myButton.Content = "Saved";
			
			await Task.Delay(1000);
			
			myButton.Background = Brushes.Transparent;
			myButton.Content = "Save Settings";
		}

		private DependencyObject LoadXaml()
		{
			if(!File.Exists(path))
			File.WriteAllText(path, "500");
			
			try
			{
				Page page;
				FileStream fs = new FileStream(System.IO.Path.Combine(NinjaTrader.Core.Globals.UserDataDir, @"bin\Custom\AddOns\MaxTradeLoss.xaml"), FileMode.Open);
				page = (Page)XamlReader.Load(fs);

				myButton = LogicalTreeHelper.FindLogicalNode(page, "myButton") as Button;
				if (myButton != null)
					myButton.Click += myButton_Click;				
								
				MaxLossBox = LogicalTreeHelper.FindLogicalNode(page, "MaxLoss") as TextBox;
				
				MaxLossBox.Text = File.ReadAllText(path);			
				
				DependencyObject pageContent = page.Content as DependencyObject;

				return pageContent;
			}
			catch (Exception ex)
			{
				Output.Process("Error LoadXAML " + ex, PrintTo.OutputTab1);
				return null;
			}
		}

		public void Restore(XDocument document, XElement element)
		{
			// This is used for restoring the elements of the document with the workspace. 
			if (MainTabControl != null)
				MainTabControl.RestoreFromXElement(element);
		}

		public void Save(XDocument document, XElement element)
		{
			// This is used for saving the elements of the document with the workspace.
			if (MainTabControl != null)
				MainTabControl.SaveToXElement(element);
		}

		public WorkspaceOptions WorkspaceOptions { get; set; }		
	}	
}
 
